do
--create an instance of the IADS
iranIADS = SkynetIADS:create()

---debug settings remove from here on if you do not wan't any output on what the IADS is doing by default
local iadsDebug = iranIADS:getDebugSettings()
iadsDebug.IADSStatus = false
iadsDebug.samWentDark = false
iadsDebug.contacts = false
iadsDebug.radarWentLive = false
iadsDebug.noWorkingCommmandCenter = false
iadsDebug.ewRadarNoConnection = false
iadsDebug.samNoConnection = false
iadsDebug.jammerProbability = false
iadsDebug.addedEWRadar = false
iadsDebug.hasNoPower = false
iadsDebug.harmDefence = false
---end remove debug ---

--add all units with unit name beginning with 'EW' to the IADS:
iranIADS:addEarlyWarningRadarsByPrefix('EW')

--add all groups begining with group name 'SAM' to the IADS:
iranIADS:addSAMSitesByPrefix('SAM')

--add a command center:
local commandCenter = StaticObject.getByName('Command-Center')
local comPowerSource = StaticObject.getByName('Command-Center-Power')
iranIADS:addCommandCenter(commandCenter):addPowerSource(comPowerSource)

--add a power source and a connection node for this EW radar:
--local powerSource = StaticObject.getByName('Power-Source-EW-Center3')
--local connectionNodeEW = StaticObject.getByName('Connection-Node-EW-Center3')
--iranIADS:getEarlyWarningRadarByUnitName('EW-Center3'):addPowerSource(powerSource):addConnectionNode(connectionNodeEW)

-- CONNECTION NODES --
----------------------
local connectionNodeEast = Unit.getByName('Connection-Node-East')
iranIADS:getSAMSiteByGroupName('SAM-SA-10-5'):addConnectionNode(connectionNodeEast)
iranIADS:getSAMSiteByGroupName('SAM-SA-10'):addConnectionNode(connectionNodeEast)
iranIADS:getSAMSiteByGroupName('SAM-SA-15-point-defence-SA-10'):addConnectionNode(connectionNodeEast)
iranIADS:getSAMSiteByGroupName('SAM-SA-11'):addConnectionNode(connectionNodeEast)

iranIADS:getEarlyWarningRadarByUnitName('EW-East'):addConnectionNode(connectionNodeEast)


local connectionSubNode1 = Unit.getByName('Connection-Node-Sub-1')
iranIADS:getEarlyWarningRadarByUnitName('EW-East'):addConnectionNode(connectionSubNode1)
iranIADS:getSAMSiteByGroupName('SAM-SA-13'):addConnectionNode(connectionSubNode1)


local connectionNodeCentral = Unit.getByName('Connection-Node-Central')
iranIADS:getSAMSiteByGroupName('SAM-SA-10-3'):addConnectionNode(connectionNodeCentral)
iranIADS:getSAMSiteByGroupName('SAM-SA-10-2'):addConnectionNode(connectionNodeCentral)

iranIADS:getEarlyWarningRadarByUnitName('EW-Center2'):addConnectionNode(connectionNodeCentral)
iranIADS:getEarlyWarningRadarByUnitName('EW-Center'):addConnectionNode(connectionNodeCentral)


local connectionSubNode2 = Unit.getByName('Connection-Node-Sub-2')
iranIADS:getSAMSiteByGroupName('SAM-SA-2'):addConnectionNode(connectionSubNode2)
iranIADS:getSAMSiteByGroupName('SAM-SA-3'):addConnectionNode(connectionSubNode2)
iranIADS:getSAMSiteByGroupName('SAM-SA-8'):addConnectionNode(connectionSubNode2)

iranIADS:getEarlyWarningRadarByUnitName('EW-West'):addConnectionNode(connectionSubNode2)


local connectionNodeWest = Unit.getByName('Connection-Node-West')
iranIADS:getSAMSiteByGroupName('SAM-SA-11-2'):addConnectionNode(connectionNodeWest)
iranIADS:getSAMSiteByGroupName('SAM-SA-10-6'):addConnectionNode(connectionNodeWest)
iranIADS:getSAMSiteByGroupName('SAM-SA-10-7'):addConnectionNode(connectionNodeWest)
iranIADS:getSAMSiteByGroupName('SAM-SA-11-2'):addConnectionNode(connectionNodeWest)

iranIADS:getEarlyWarningRadarByUnitName('EW-Center'):addConnectionNode(connectionNodeWest)
iranIADS:getEarlyWarningRadarByUnitName('EW-Center3'):addConnectionNode(connectionNodeWest)
iranIADS:getEarlyWarningRadarByUnitName('EW-West'):addConnectionNode(connectionNodeWest)


local connectionNode = Unit.getByName('Mobile-Command-Post-SAM-SA-2')
iranIADS:getSAMSiteByGroupName('SAM-SA-2'):addConnectionNode(connectionNode):setAutonomousBehaviour(SkynetIADSAbstractRadarElement.AUTONOMOUS_STATE_DARK)

--this SA-2 site will go live at 70% of its max search range:
iranIADS:getSAMSiteByGroupName('SAM-SA-2'):setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE):setGoLiveRangeInPercent(70)

--all SA-10 sites shall act as EW sites, meaning their radars will be on all the time:
--iranIADS:getSAMSitesByNatoName('SA-10'):setActAsEW(true)

-- POINT DEFENCES --
--------------------
--set the sa15 as point defence for the SA-10 site
iranIADS:getSAMSiteByGroupName('SAM-SA-10'):addPointDefence(iranIADS:getSAMSiteByGroupName('SAM-SA-15-point-defence-SA-10')):setHARMDetectionChance(70):setIgnoreHARMSWhilePointDefencesHaveAmmo(true)

iranIADS:getSAMSiteByGroupName('SAM-SA-10-2'):addPointDefence(iranIADS:getSAMSiteByGroupName('SAM-SA-15-point-defence-SA-10-2')):setHARMDetectionChance(70):setIgnoreHARMSWhilePointDefencesHaveAmmo(true)

iranIADS:getSAMSiteByGroupName('SAM-SA-10-6'):addPointDefence(iranIADS:getSAMSiteByGroupName('SAM-SA-15-point-defence-sa-10-6')):setHARMDetectionChance(70):setIgnoreHARMSWhilePointDefencesHaveAmmo(true)

iranIADS:getEarlyWarningRadarByUnitName('EW-Center2'):addPointDefence(iranIADS:getSAMSiteByGroupName('SAM-SA-15-point-defence-EW-center2')):setHARMDetectionChance(70):setIgnoreHARMSWhilePointDefencesHaveAmmo(true)
iranIADS:getEarlyWarningRadarByUnitName('EW-West3'):addPointDefence(iranIADS:getSAMSiteByGroupName('SAM-SA-19-point-defence-EW-West3')):setHARMDetectionChance(70):setIgnoreHARMSWhilePointDefencesHaveAmmo(true)




--set this SA-11 site to go live 70% of max range of its missiles (default value: 100%), its HARM detection probability is set to 50% (default value: 70%)
iranIADS:getSAMSiteByGroupName('SAM-SA-11'):setGoLiveRangeInPercent(70):setHARMDetectionChance(60)

--this SA-6 site will always react to a HARM being fired at it:
iranIADS:getSAMSiteByGroupName('SAM-SA-6'):setHARMDetectionChance(100)

--set this SA-11 site to go live at maximunm search range (default is at maximung firing range):
iranIADS:getSAMSiteByGroupName('SAM-SA-11-2'):setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE)

--activate the radio menu to toggle IADS Status output
iranIADS:addRadioMenu()

iranIADS:activate()	


end